import Vue from 'vue'
import App from './App'
import uView from "uview-ui";
import store from "@/common/store";
import {
	router,
	RouterMount
} from "@/common/router";
import common from "@/common";
import TuniaoUI from 'tuniao-ui';
import Tuniaostore from './store';
import ws from "@/store/ws.js";
import base64 from '@/store/base64';

// 引入请求封装 
require('./utils/request/index')(app)

let vuexStore = require('@/store/$t.mixin.js');
async function bootstrap() {
	App.mpType = "app";

	// 可以通过下面的方式手动注册
	// Vue.use(vant.Lazyload);
	//引入路由
	Vue.use(router);
	// 引入全局uView
	Vue.use(uView);
	// 加载common
	Vue.use(common);
	Vue.prototype.$ws = ws;
	Vue.prototype.$base64 = base64;
	// 引入全局图鸟ui
	Vue.use(TuniaoUI);
	Vue.mixin(vuexStore);
	const app = new Vue({
		store,
		Tuniaostore,
		...App
	});
	// #ifdef H5
	RouterMount(app, router, "#app");
	// #endif
	// #ifndef H5
	app.$mount();
	// #endif
}

bootstrap();